(cl:defpackage :std.char.unicode
  (:use)
  (:local-nicknames (:% :std.internal)))
(cl:in-package :std.char.unicode)

;; TODO: maybe this namespace should simply extend std.char when loaded?

(%:fn/macro category-general ((character char)) sb-unicode:general-category)
(%:fn/macro class-bidirectional ((character char)) sb-unicode:bidi-class)
(%:fn/macro class-combining ((character char)) sb-unicode:combining-class)
(%:fn/macro break-class-grapheme (char) sb-unicode:grapheme-break-class)
(%:fn/macro break-class-word (char) sb-unicode:word-break-class)
(%:fn/macro break-class-sentence (char) sb-unicode:sentence-break-class)
(%:fn/macro break-class-line (character) sb-unicode:line-break-class)
;; TODO: what is 'resolve'?? Is it a boolean flag?
(%:fn/macro value-decimal ((character char) :key resolve) sb-unicode:decimal-value)
(%:fn/macro value-digit ((character char)) sb-unicode:digit-value)
(%:fn/macro value-numeric ((character char)) sb-unicode:numeric-value)
(%:fn/macro mirrored? ((character char)) sb-unicode:mirrored-p)
(%:fn/macro mirror-bidi ((character char)) sb-unicode:bidi-mirroring-glyph)
(%:fn/macro age ((character char)) sb-unicode:age)
(%:fn/macro hangul-syllable-type ((character char)) sb-unicode:hangul-syllable-type)
(%:fn/macro east-asian-width ((character char)) sb-unicode:east-asian-width)
(%:fn/macro script ((character char)) sb-unicode:script)
(%:fn/macro char-block ((character char)) sb-unicode:char-block)
(%:fn/macro unicode-1-name ((character char)) sb-unicode:unicode-1-name)
(%:fn/macro proplist? ((character char) property) sb-unicode:proplist-p)
(%:fn/macro uppercase? ((character char)) sb-unicode:uppercase-p)
(%:fn/macro lowercase? ((character char)) sb-unicode:lowercase-p)
(%:fn/macro cased? ((character char)) sb-unicode:cased-p)
(%:fn/macro case-ignorable? ((character char)) sb-unicode:case-ignorable-p)
(%:fn/macro alphabetic? ((character char)) sb-unicode:alphabetic-p)
(%:fn/macro ideographic? ((character char)) sb-unicode:ideographic-p)
(%:fn/macro math? ((character char)) sb-unicode:math-p)
(%:fn/macro whitespace? ((character char)) sb-unicode:whitespace-p)
;; TODO: what type is this argument?
(%:fn/macro hex? ((character char) :key ascii) sb-unicode:hex-digit-p)
(%:fn/macro default-ignorable? ((character char)) sb-unicode:default-ignorable-p)
